package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMEQWL;
import cn.ibizlab.eam.core.eam_core.filter.EMEQWLSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQWL] 服务对象接口
 */
public interface IEMEQWLService extends IService<EMEQWL>{

    boolean create(EMEQWL et) ;
    void createBatch(List<EMEQWL> list) ;
    boolean update(EMEQWL et) ;
    void updateBatch(List<EMEQWL> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEQWL get(String key) ;
    EMEQWL getDraft(EMEQWL et) ;
    boolean checkKey(EMEQWL et) ;
    boolean save(EMEQWL et) ;
    void saveBatch(List<EMEQWL> list) ;
    Page<EMEQWL> searchDefault(EMEQWLSearchContext context) ;
    Page<EMEQWL> searchNearest30DayByEQ(EMEQWLSearchContext context) ;
    List<EMEQWL> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEQWL> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMEQWL> selectByWoid(String emwoid) ;
    void removeByWoid(String emwoid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMEQWL> getEmeqwlByIds(List<String> ids) ;
    List<EMEQWL> getEmeqwlByEntities(List<EMEQWL> entities) ;
}


